#  C1010.defn.tcl

proc {Add_C1010_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
#   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register $name xVME run      "-a$A16addrbase -w16 -o1 -pwo -d8 -zx"
   define-vme-register $name xVME status   "-a$A16addrbase -w16 -o3 -pro -d8 -zx"
   define-vme-register $name xVME control  "-a$A16addrbase -w16 -o3 -pwo -d8 -zx"
   define-vme-register $name xVME opt      "-a$A16addrbase -w16 -o5 -pwo -d8 -zd"
   define-vme-register $name xVME intrv    "-a$A16addrbase -w16 -o7 -pwo -d8 -zd"

   define-vme-register $name xVME ScalerRAM     "-a$A32addrbase -w32 -o0 -prw -d16 -zd"
   define-vme-register $name xVME CounterRAM    "-a$A32addrbase -w32 -o0x800 -prw -d16 -zd"
}


proc {C1010_DAQ-reset} {args} {
#   C1010
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {C1010_DAQ-go} {args} {
#   C1010
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

    write-vme-register $module.control 1    ;#  set CLEAR state
    write-vme-register $module.run 4
}

proc {C1010_DAQ-halt} {args} {
#   C1010
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

    write-vme-register $module.run 0
}

proc {C1010_DAQ-setup} {args} {
#   C1010
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

}

#   for parameter save/restore
set {C1010_registersavepatterns} {opt}


