

#    register access procedures common to all IP pack diagnostic tasks


proc define-register {class name attributes} {
   global resource mname
   set register /$resource/$mname.$name
   set-footer "defining register $register"
   catch {EG "register :name '$register' :class '$class' !new"}
   if {$attributes != ""} then {EG "register :name '$register' :object '$attributes'"}
   clear-footer
}

proc write-register {name value} {
   global testmode resource mname
   global monitor
   set register /$resource/$mname.$name
   if {$monitor != 0} then {set-footer "writing $value to $register"}
   EG "register :name '$register' :value '$value'"
   if {$testmode == 1} then {insert-debug "writing $value to $register"}
   if {$monitor != 0} then {clear-footer}
}

proc write-registers {name value} {
   global testmode resource mname
   global monitor
   set register /$resource/$mname.$name
   if {$monitor != 0} then {set-footer "writing $value to $register"}
   EG "register :pattern '$register' :value '$value'"
   if {$testmode == 1} then {insert-debug "writing $value to $register"}
   if {$monitor != 0} then {clear-footer}
}

proc read-register {name} {
   global testmode resource mname
   global monitor
   set register /$resource/$mname.$name
   if {$monitor != 0} then {set-footer "reading $register"}
   set value [EG "register :name '$register' ?value"]
   if {$testmode == 1} then {insert-debug "$register returned $value"}
   if {$monitor != 0} then {clear-footer}
   return $value
}

proc initialise-register {name} {
   global testmode resource mname
   global monitor
   set register /$resource/$mname.$name
   if {$monitor != 0} then {set-footer "initialising $register"}
   EG "register :name '$register' !initialise"
   if {$testmode == 1} then {insert-debug "initialising $register"}
   if {$monitor != 0} then {clear-footer}
}

proc rr {name} {read-register $name}
proc wr {name value} {write-register $name $value}
